<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<div class="w-full flex flex-col items-end">
  <div class="pb-6 flex items-center">
    <p-button [link]="true" label="refresh" icon="pi pi-sync" size="small" (onClick)="refresh()"></p-button>
    <div class="w-0.5 h-4 bg-borderGrey mr-4"></div>
    <div class="w-full flex items-center justify-end gap-2">
      <ng-container *ngFor="let item of filterOptions">
        <div
          [ngClass]="{
            'filter-button-active': item == selectedStatus,
            'filter-button-inactive': item != selectedStatus
          }"
          (click)="toggleFilter(item)"
        >
          {{ item | titlecase }}
        </div>
      </ng-container>
    </div>
  </div>
  <ng-container *ngLet="initializing$ | async as initializing">
    <div class="grow w-full">
      <app-table-skeleton *ngIf="initializing" [includeSearch]="false"></app-table-skeleton>
      <p-table
        *ngIf="!initializing"
        [value]="compact ? auditTrails.slice(0, 5) : auditTrails"
        dataKey="id"
        [tableStyle]="{ 'min-width': '50rem' }"
        [scrollable]="true"
        [paginator]="!compact"
        [lazy]="true"
        [totalRecords]="totalRecords"
        [rows]="25"
        (onPage)="onPage($event)"
      >
        <ng-template pTemplate="header">
          <tr>
            <th style="width: 5rem"></th>
            <th pFrozenColumn>Status</th>
            <th pFrozenColumn>Purpose</th>
            <th>Method</th>
            <th>Path</th>
            <th></th>
          </tr>
        </ng-template>
        <ng-template pTemplate="body" let-trail let-expanded="expanded">
          <ng-container *ngLet="loading$ | async as loading">
            <tr>
              <ng-container *ngIf="loading">
                <td colspan="6">
                  <p-skeleton height="42px" width="100%"></p-skeleton>
                </td>
              </ng-container>
              <ng-container *ngIf="!loading">
                <td [class]="{ '!border-b-white': expanded }">
                  <p-button
                    type="button"
                    pRipple
                    [pRowToggler]="trail"
                    [text]="true"
                    [rounded]="true"
                    [plain]="true"
                    [icon]="expanded ? 'pi pi-chevron-down' : 'pi pi-chevron-right'"
                  />
                </td>
                <td [class]="{ '!border-b-white': expanded }">
                  <div *ngIf="isMissing(trail.status)" class="text-text-300">{{ trail.status | uppercase }}</div>
                  <div
                    *ngIf="!isMissing(trail.status)"
                    class="flex items-center gap-2"
                    [style]="{ color: statusColor(trail.status) }"
                  >
                    <i [class]="statusIcon(trail.status)"></i>
                    <div class="font-semibold">{{ trail.status | uppercase }}</div>
                  </div>
                </td>

                <td [class]="{ '!border-b-white': expanded }">
                  <div *ngIf="isMissing(trail.purpose)" class="text-text-300">{{ trail.purpose | uppercase }}</div>
                  <div *ngIf="!isMissing(trail.purpose)" class="flex items-center gap-2">
                    <i [class]="purposeIcon(trail.purpose)"></i>
                    <div>{{ trail.purpose | uppercase }}</div>
                  </div>
                </td>

                <td [class]="{ '!border-b-white': expanded }">
                  <div *ngIf="isMissing(trail.method)" class="text-text-300">{{ trail.method | uppercase }}</div>
                  <div *ngIf="!isMissing(trail.method)">{{ trail.method | uppercase }}</div>
                </td>

                <td [class]="{ '!border-b-white': expanded }">
                  <div *ngIf="isMissing(trail.path)" class="text-text-300">{{ trail.path }}</div>
                  <div *ngIf="!isMissing(trail.path)" class="max-w-[200px]">{{ trail.path }}</div>
                </td>

                <td [class]="{ '!border-b-white': expanded }">
                  <div class="w-full flex justify-end">
                    <div class="text-sm text-text-300 w-40">
                      <div>created: {{ trail.ts | applyLocalTzPipe | date : 'medium' }}</div>
                    </div>
                  </div>
                </td>
              </ng-container>
            </tr>
          </ng-container>
        </ng-template>
        <ng-template pTemplate="rowexpansion" let-trail>
          <tr>
            <td colspan="6">
              <div class="px-20 pb-8">
                <div class="section flex flex-col">
                  <div class="flex items-center gap-2">
                    <div class="text-text-300">Origin:</div>
                    <div *ngIf="isMissing(trail.origin)" class="text-text-300">{{ trail.origin }}</div>
                    <div *ngIf="!isMissing(trail.origin)">
                      <app-long-id *ngIf="trail.origin != 'SELF'" [id]="trail.origin" [width]="110"></app-long-id>
                      <div *ngIf="trail.origin == 'SELF'">{{ trail.origin }}</div>
                    </div>
                  </div>
                  <div class="flex items-center gap-2">
                    <div class="text-text-300">Requester:</div>
                    <div *ngIf="isMissing(trail.requester)" class="text-text-300">{{ trail.requester }}</div>
                    <app-long-id *ngIf="!isMissing(trail.requester)" [id]="trail.requester" [width]="105"></app-long-id>
                  </div>
                  <div *ngIf="!isMissing(trail.target)" class="flex items-center gap-2">
                    <div class="text-text-300">Target:</div>
                    <app-long-id [id]="trail.target" [width]="105"></app-long-id>
                  </div>
                  <div *ngIf="!isMissing(trail.statusreason)" class="flex items-start gap-2 mt-4">
                    <div class="text-text-300">Status Reason:</div>
                    <div class="overflow-x-auto" [class]="{ 'max-w-[600px]': compact, 'max-w-[800px]': !compact }">
                      {{ trail.statusreason }}
                    </div>
                  </div>
                  <div *ngIf="!isMissing(trail.info)" class="flex flex-col mt-4">
                    <div class="text-text-300">Info:</div>
                    <div class="overflow-x-auto" [class]="{ 'max-w-[720px]': compact, 'max-w-[800px]': !compact }">
                      <pre>{{ trail.info | json }}</pre>
                    </div>
                  </div>
                </div>
              </div>
            </td>
          </tr>
        </ng-template>
        <ng-template pTemplate="emptymessage" let-columns>
          <tr>
            <td colspan="6">
              <div class="flex flex-col w-full h-32 justify-center text-center">
                <app-sad-face></app-sad-face>
                No Audit Trails
              </div>
            </td>
            <td></td>
          </tr>
        </ng-template>
      </p-table>
    </div>
  </ng-container>
</div>
